//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
#include "TDirectDrawFastForm.h"
#include "winresrc.h"
#include "penwin.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
TDirectDrawFastForm *DirectDrawFastForm;
//---------------------------------------------------------------------------
// note: the following macros are used so that no-one knows what the private
// 		 methods are used for.
#define		ExcludeAllControls			Func2
#define 	ExcludeOtherForms			Func3
#define 	ExcludeMenu					Func4
#define 	PaintFrame					Func5
#define 	PaintCommandButton			Func6
#define 	PaintCaption				Func7
#define 	PaintMinimizeButton			Func8
#define 	PaintMaximizeButton			Func9
#define 	PaintRestoreButton			Func10
#define 	PaintCloseButton			Func11
#define 	MyFrame3DWindow				Func12
#define 	MyFrame3DButton				Func13
#define 	MyFrame3DThumbnail			Func14
#define 	PaintListBox				Func15
#define 	PaintScrollBoxVScrollBar	Func16
#define 	PaintScrollBoxHScrollBar	Func17
#define 	PaintFormVScrollBar			Func18
#define 	PaintFormHScrollBar			Func19
//---------------------------------------------------------------------------
// remember: 	SetPriorityClass(hProcess: THandle; dwPriorityClass: DWORD): BOOL; stdcall;
//				USAGE: SetPriorityClass( GetCurrentProcess(), HIGH_PRIORITY_CLASS );
// remember:	Frame3D(Canvas, Rect, TopColor, BottomColor, BevelWidth);
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall TDirectDrawFastForm::TDirectDrawFastForm(TComponent* Owner)
	: TForm(Owner)
{
fIsGraphic = NULL;
fHandlingWMPAINT = false;
fFormIsMoveable = false;

// get the width, height of the minimized bar
MINIMIZEDMETRICS minmetrics;
minmetrics.cbSize = sizeof(MINIMIZEDMETRICS);
SystemParametersInfo( SPI_GETMINIMIZEDMETRICS, sizeof(MINIMIZEDMETRICS), &minmetrics, 0 );

fMinimizeX = minmetrics.iWidth;
fBorderX = GetSystemMetrics(SM_CXDLGFRAME);
fBorderY = GetSystemMetrics(SM_CYDLGFRAME);
fCaptionHeight = GetSystemMetrics(SM_CYCAPTION);

fFormIsBeingRestored = false;
fFormIsBeingMinimized = false;
fFormIsBeingMaximized = false;

fFramesFlipped = 0;

if (DirectDraw == NULL) DirectDraw = new TDirectDraw(this);
if (DirectDraw != NULL)
	{
    for (int i=0;i<ControlCount;i++) Controls[i]->Visible = false;
//    if (ControlCount>0)
//    	{
//	    fIsGraphic = new bool[ControlCount];
//	    for (int i=0;i<ControlCount;i++) fIsGraphic[i] = Controls[i] );
//        }
    }
}
//---------------------------------------------------------------------------
__fastcall 	TDirectDrawFastForm::~TDirectDrawFastForm()
{
if (DirectDraw != NULL)
	{
//    if (ControlCount>0) if (fIsGraphic!=NULL) delete[] fIsGraphic;
	if (DirectDraw->Owner == this)
		{
	    delete DirectDraw;
	    DirectDraw = NULL;
	    }
    }
}
//---------------------------------------------------------------------------
void 	__fastcall TDirectDrawFastForm::WndProc(Messages::TMessage &Message)
{
if (DirectDraw == NULL)
	{
    TForm::WndProc(Message);
    return;
    }

// handle any repaint messages coming from Windows rather than letting the default
// WndProc function handle them as the default WndProc function automatically draws
// the form when receiving WM_PAINT, WM_NCPAINT, WM_NCACTIVATE.....
// since the form redrawing code uses a windows gdi Paint3d function which blits to
// the display on completion (we have no control over this), it is probably better
// to use our own handler so that we can control exactly when to blit what.

// pre-VCL message handling
switch (Message.Msg)
	{
    case WM_ERASEBKGND:

        Message.Result = 0;		// don't do anything at all
		return;

   case WM_PAINT:

    	if ((DirectDraw != NULL) && !fHandlingWMPAINT && Visible)
        	if (!fFormIsBeingMinimized)// && !fFormIsBeingMaximized && !fFormIsBeingRestored)
		    	{
		        fHandlingWMPAINT = true;

		        HDC hdc = DirectDraw->GetBackBufferDC();

	            if (hdc != NULL)
	            	{
					// determine the bounds of the frame that we have to paint
					RECT form_r;

	                // when the window is minimized, retrieve relevant sizes,
	                // and overwrite our internal location & size variables that are
	                // setup each time we get a WM_SIZE or WM_MOVE message.
					if (WindowState == wsMinimized)
	                   	{
	                    // get the top, left of the minimized bar
	                    WINDOWPLACEMENT wndplace;
	                    wndplace.length = sizeof(WINDOWPLACEMENT);
	                    GetWindowPlacement( Handle, &wndplace );

	                    form_r.left = wndplace.ptMinPosition.x;
	                    form_r.top = wndplace.ptMinPosition.y;

	                    // get the width, height of the minimized bar
	                    MINIMIZEDMETRICS minmetrics;
	                    minmetrics.cbSize = sizeof(MINIMIZEDMETRICS);
						SystemParametersInfo( SPI_GETMINIMIZEDMETRICS, sizeof(MINIMIZEDMETRICS), &minmetrics, 0 );

		                form_r.right = form_r.left + minmetrics.iWidth + 2*fBorderX;
		                form_r.bottom = form_r.top + fBorderY + fCaptionHeight + 2;
	                    }
					else
	                   	{
		                form_r.left = Left;
						form_r.top  = Top;
			            form_r.right = form_r.left+Width;
			           	form_r.bottom = form_r.top+Height;
	                    }

		            // tell windows that the region of the whole form (ie. including frame)
                    // is to be repainted (note: this sets the clip region to the whole form)
		            InvalidateRect(Handle,&form_r,false);

                    // adjust the clip rect so that all drawing is clipped to the form area
                    HRGN form_hrgn = CreateRectRgn( form_r.left, form_r.top, form_r.right, form_r.bottom );
                    SelectClipRgn( hdc, form_hrgn );
                    DeleteObject( form_hrgn );

					// make sure not to paint over any other forms
					ExcludeOtherForms( Handle, hdc );

                    // paint the frame
//                    PaintFrame(hdc,form_r);

	                // only paint internals when the form is not minimized
	                RECT client_r;
	                client_r.top = 0;
	                client_r.left = 0;
	                client_r.right = 0;
	                client_r.bottom = 0;
		            if (WindowState != wsMinimized)
    	               	{
		                client_r = form_r;
	   	                // determine the client area just inside the frame
	                    client_r.left += fBorderX;
		    			client_r.top += fBorderY + fCaptionHeight;
		                client_r.right -= fBorderX;
		                client_r.bottom -= fBorderY;

	                    // clear the default clip region
	                    SelectClipRgn( hdc, NULL );

			            // tell windows that the region of the whole form (ie. including frame)
		                // is to be repainted (note: this sets the clip region to the whole form)
			            InvalidateRect(Handle,&client_r,false);

			            // adjust the clip rect so that all drawing is clipped to the client area
			            HRGN client_hrgn = CreateRectRgn( client_r.left, client_r.top, client_r.right, client_r.bottom );
			            SelectClipRgn( hdc, client_hrgn );
			            DeleteObject( client_hrgn );

						// make sure not to paint over any other forms
	                    ExcludeOtherForms( Handle, hdc );

				        // move the draw start location to the top,left of the form's client area
		                int dy = client_r.top;
						MoveWindowOrg( hdc, client_r.left, dy );

	                    // clear underneath the area we need to repaint
	                    try
	                    	{
	                        Canvas->Handle = hdc;
							Canvas->Brush->Color = Color;
							Canvas->Brush->Style = bsSolid;
							Canvas->FillRect( ClientRect );
	                        }
	                    catch ( ... ) {}
						Canvas->Handle = NULL;

			 			Messages::TWMPaint	MyPaintMessage;
						MyPaintMessage.Msg = WM_PAINT;
						MyPaintMessage.DC  = hdc;
						MyPaintMessage.Unused = 0;
						MyPaintMessage.Result = 0;
						PaintHandler( MyPaintMessage );

						MoveWindowOrg( hdc, -client_r.left, -dy );
	                    }

		            hdc = DirectDraw->ReleaseBackBufferDC();

                    if (WindowState != wsMinimized)
		                if ((client_r.right!=client_r.left) && (client_r.bottom!=client_r.top))
							{
		                	DirectDraw->FlipBackBufferRect( client_r.left, client_r.top, client_r.right-client_r.left, client_r.bottom-client_r.top );
		                    fFramesFlipped++;
		                    }

		            // let windows know that we've handled the WM_PAINT message
			        Message.Msg = 0;
		            // let "this" know that we've handled the WM_PAINT message
			        fHandlingWMPAINT = false;
		            // let windows know that we've handled the WM_PAINT message
					ValidateRect( Handle, NULL );
	                }
	 	        else
                	{
                    // simply clear relevant flags
                    if (fFormIsBeingRestored) 	fFormIsBeingRestored = false;
	            	if (fFormIsBeingMinimized) 	fFormIsBeingMinimized = false;
                    if (fFormIsBeingMaximized) 	fFormIsBeingMaximized = false;
                    // tell windows that the window has been redrawn (even though it hasn't)
                    ValidateRect( Handle, NULL );
                    }
	        }
        return;

	case WM_SYSCOMMAND:

        // determine if the form is about to be resized using the minimize, maximize, restore
        // system commands.
        // the reason for doing this is that when the vcl / windows handles this message, it
        // generates a WM_PAINT message before updating TForm::WindowState.
        // ie. we don't know how to paint the form otherwise.
        {
        int sysmsg = (Message.WParam & 0x0000FFF0);
        if (Application->MainForm != this)
        	{
            fFormIsBeingRestored  = (sysmsg == SC_RESTORE);
	        fFormIsBeingMinimized = (sysmsg == SC_MINIMIZE);
	        fFormIsBeingMaximized = (sysmsg == SC_MAXIMIZE);
	        }
        }
		break;
	}

// let the VCL handle the message
TForm::WndProc(Message);

switch (Message.Msg)
   	{
	case WM_MOVE:

//        OnMove();
        Perform(WM_PAINT, 0, 0);
        break;
    }
}
//---------------------------------------------------------------------------
void __fastcall	TDirectDrawFastForm::ExcludeOtherForms( HWND Handle, HDC hdc )
{
// start at the z-factor of our current form
HWND hwnd = GetWindow( Handle, GW_HWNDPREV );
// scan through all other windows all higher z-factors
while (hwnd != NULL)
	{
    // determine the visible state of the relevant form
    TForm* form = NULL;
    for (int j=0;j<Screen->FormCount;j++)
    	if (Screen->Forms[j]->Handle == hwnd)
        	{
            form = Screen->Forms[j];
            break;
            }
    bool form_is_visible = false;
    if (form != NULL) form_is_visible = form->Visible;

    // if the form is visible, make sure not to paint over it...
    if (form_is_visible)
     	{
        RECT exclude_r;
        // if the form is minimized, get the sizes of the minimized caption bar
		if (form->WindowState == wsMinimized)
           	{
            // get the top, left of the minimized bar
            WINDOWPLACEMENT wndplace;
            wndplace.length = sizeof(WINDOWPLACEMENT);
            GetWindowPlacement( form->Handle, &wndplace );

            exclude_r.left = wndplace.ptMinPosition.x;
            exclude_r.top  = wndplace.ptMinPosition.y;
	        exclude_r.right = exclude_r.left + fMinimizeX + 2*fBorderX;
	        exclude_r.bottom = exclude_r.top + fBorderY + fCaptionHeight + 2;

			ExcludeClipRect( hdc, exclude_r.left, exclude_r.top, exclude_r.right, exclude_r.bottom );
            }
        else
           	// exclude the entire form area
           	{
            exclude_r.left = form->Left;
            exclude_r.top = form->Top;
            exclude_r.right = exclude_r.left + form->Width;
            exclude_r.bottom = exclude_r.top + form->Height;
			ExcludeClipRect( hdc, exclude_r.left, exclude_r.top, exclude_r.right, exclude_r.bottom );
           	}
        }

	// go to the window with the next highest z-order & repeat
    hwnd = GetWindow( hwnd, GW_HWNDPREV );
    }
}
//---------------------------------------------------------------------------
void __fastcall	TDirectDrawFastForm::ExcludeAllControls( HDC hdc )
{
for (int i=0;i<ControlCount;i++)
	if (Controls[i]->Visible)
		{
	    TControl* control = Controls[i];
	    ExcludeClipRect( hdc, control->Left,control->Top,control->Left+control->Width,control->Top+control->Height);
	    }
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawFastForm::PaintHandler(Messages::TWMPaint &Message)
{
// simply check our preconditions & skip out if not appropriate
if (DirectDraw == NULL)
	{
    TForm::PaintHandler(Message);
    return;
    }

//DirectDraw->Debug(DBG_IN,"<<FORM>>::PaintHandler()","");

// if the supplied DC is okay
HDC hdc = Message.DC;

// use standard function calls to paint to our DirectX surface
try
  	{
    int	SaveIndex;
    int Clip;

    if (ControlCount==0)
    	{
//		DirectDraw->Debug(DBG_NOTE,"<<FORM>>::PaintHandler()","no controls, simply painting window");
        PaintWindow(hdc);
        }
    else
    	{
//		DirectDraw->Debug(DBG_NOTE,"<<FORM>>::PaintHandler()","has controls, calculating clip extent");
        SaveIndex = SaveDC( hdc );
	    Clip = SIMPLEREGION;
        for (int i=0;i<ControlCount;i++)
			{
            bool control_is_visible = Controls[i]->Visible;
		    bool control_design_visible = !Controls[i]->ControlStyle.Contains(csNoDesignVisible);

		   	if (control_is_visible && control_design_visible)
				{
	            Clip = ExcludeClipRect( hdc, Controls[i]->Left,
	            							 Controls[i]->Top,
	            							 Controls[i]->Left + Controls[i]->Width,
	                                         Controls[i]->Top + Controls[i]->Height );
	            if (Clip == NULLREGION) break;
	            }
            }
        if (Clip != NULLREGION)
        	{
//			DirectDraw->Debug(DBG_NOTE,"<<FORM>>::PaintHandler()","clip region is not null, painting window");
            PaintWindow( hdc );
            }
//        else
//   			DirectDraw->Debug(DBG_NOTE,"<<FORM>>::PaintHandler()","clip region is null, NOT painting window");

        RestoreDC( hdc, SaveIndex );
        }
	//	DirectDraw->Debug(DBG_NOTE,"<<FORM>>::PaintHandler()","painting controls");
    PaintControls( hdc, NULL );
	}
// unless a problem occurs
catch (...)
	{
//	DirectDraw->Debug(DBG_OUT,"<<FORM>>::PaintHandler()","VCL paint on DirectX DC - NOT SUCCESSFUL!");
	}
//DirectDraw->Debug(DBG_OUT,"<<FORM>>::PaintHandler()","");
}
//---------------------------------------------------------------------------
void	__fastcall	TDirectDrawFastForm::PaintWindow(HDC hdc)
{
if (hdc == NULL) return;
if (DirectDraw == NULL)
	{
    TForm::PaintWindow(hdc);
    return;
    }

//DirectDraw->Debug(DBG_IN,"<<FORM>>::PaintWindow()","");

Canvas->Handle = NULL;
Canvas->Handle = hdc;
try
	{
    Paint();
    }
catch ( ... ) {}
Canvas->Handle = NULL;

//DirectDraw->Debug(DBG_OUT,"<<FORM>>::PaintWindow()","");
}
//---------------------------------------------------------------------------
void	__fastcall	TDirectDrawFastForm::PaintControls(HDC hdc, TControl* First)
{
}
//---------------------------------------------------------------------------
void	__fastcall TDirectDrawFastForm::Repaint()
{
if (DirectDraw == NULL)
	{
    TForm::Repaint();
    return;
    }

if (Visible)
	{
    InvalidateRect(Handle,NULL,false);
	UpdateWindow(Handle);
    }
}
//---------------------------------------------------------------------------
void 	__fastcall TDirectDrawFastForm::BeforeMove()
{
}
//---------------------------------------------------------------------------
void 	__fastcall TDirectDrawFastForm::AfterMove()
{
}
//---------------------------------------------------------------------------


